Subject: bug#66941: 29.1; Emacs on Windows can't display CJK characters correctly in svg images

From: Alan Third <[email-masked]>
Date: Mon, 6 Nov 2023 12:57:04 +0000

On Mon, Nov 06, 2023 at 02:21:25PM +0200, Eli Zaretskii wrote:
> > Date: Sun, 5 Nov 2023 23:27:23 +0000
> > From: Alan Third <[email-masked]>
> > Cc: [email-masked], [email-masked]
> > 
> > On Sun, Nov 05, 2023 at 08:54:27AM +0200, Eli Zaretskii wrote:
> > > Could be a problem with the font used by librsvg to show text?  Maybe
> > > the font doesn't have any non-ASCII characters.
> > 
> > This seems plausible. It should be possible to check by over-riding
> > the CSS with a font you know should work:
> > 
> > (progn
> >   (require 'svg)
> >   (switch-to-buffer "*svg-test*")
> >   (let ((svg-image (svg-create 200 200))
> >         (inhibit-read-only t))
> >     (erase-buffer)
> >     (svg-text svg-image "我喜欢自由软件" :y 100 :x 50)
> >     (insert-image (svg-image svg-image :css "svg{font-family:\"Noto Sans Mono CJK HK\";}"))))
> > 
> > Choose a font you know can show the text you're testing. I've a vague
> > memory that the Noto CJK fonts behave slightly oddly on Windows, so
> > maybe something else is a better choice.
> > 
> > I think setting the :css attribute to an empty string should reset
> > librsvg so it will use its default font settings and that would let
> > us see if it works right without our customisation.
> 
> Thanks.  I tried the above, and it didn't work, at least with (old)
> librsvg 2.40.1 I have here.  Moreover, if I use a plain ASCII string,
> which does display, the font used for display is identical whether or
> not I specify font-family in the :css attribute, so I think somehow
> this attribute doesn't have any effect.

Ah, OK. CSS only works on librsvg 2.48 and above.

This means that, at least for you, Emacs has no effect on the font
used by librsvg, it will be using its default. I've no idea what that
is and a quick look through the librsvg code hasn't helped.

It should be possible to over-ride it in the svg file itself, but
that's really up to the user.

I don't know how librsvg handles fallbacks for glyphs the font doesn't
support or if there's any way for us to over-ride its behaviour.

> Is it possible to specify a font rather than font-family?  Font
> families are treated poorly on MS-Windows, so I'd prefer to specify a
> particular font, to be sure.

This is how CSS works even in web browsers, I don't think there's a
separate "font" option.
-- 
Alan Third